#include <vector>
#include <iostream>
#include <cstdlib>
#include <ctime>
#include <cmath>
using namespace std;

int main() {
    srand(42);

    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;
    size_t number_count;
    cerr << "Enter number count: ";
    cin >> number_count;

    string choice;
    cerr << "Generate numbers?: ";
    cin >> choice;

    vector<double> numbers(number_count);
    if (choice == "yes") {
        for (size_t i = 0; i < number_count; i++) {
            numbers[i] = 0;
            for (int j = 0; j < 12; j++) {
                numbers[i] += rand();
            }
        }
    }
    else
    {
        cerr << "Enter numbers: ";
        for (size_t i = 0; i < number_count; i++) {
            cin >> numbers[i];
        }
    }

    size_t bin_count;
    cerr << "Enter bin count: ";
    cin >> bin_count;

    vector<size_t> bins(bin_count, 0);

    double min = numbers[0];
    double max = numbers[0];
    for (double x : numbers) {
        if (x < min) {
            min = x;
        }
        else if (x > max) {
            max = x;
        }
    }

    double bin_size = (max - min) / bin_count;

    for (size_t i = 0; i < number_count; i++) {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++) {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi)) {
                bins[j]++;
                found = true;
            }
        }
        if (!found) {
            bins[bin_count - 1]++;
        }
    }

    size_t max_bin_count = 0;
    for (size_t bin : bins) {
        if (bin > max_bin_count) {
            max_bin_count = bin;
        }
    }

    for (size_t i = 0; i < bin_count; i++) {
        cout << bins[i] << " |";
        size_t height = (max_bin_count <= MAX_ASTERISK) ? bins[i] : static_cast<size_t>(MAX_ASTERISK * (static_cast<double>(bins[i]) / max_bin_count));
        for (size_t j = 0; j < height; j++) {
            cout << "*";
        }
        cout << endl;
    }

    return 0;
}
